Package org.springframework.expression.spel.ast

# Class CompoundExpression

java.lang.Object
org.springframework.expression.spel.ast.SpelNodeImpl
org.springframework.expression.spel.ast.CompoundExpression

All Implemented Interfaces:
  `org.springframework.asm.Opcodes`, `SpelNode`

public class CompoundExpression extends SpelNodeImpl
Represents a DOT separated expression sequence, such as `property1.property2.methodOne()` or `property1?.property2?.methodOne()` when the null-safe navigation operator is used.

May also contain array/collection/map indexers, such as `property1[0].property2['key']`.

Since:
  3.0
Author:
  Andy Clement, Sam Brannen

## Field Summary

### Fields inherited from class org.springframework.expression.spel.ast.SpelNodeImpl

`children, exitTypeDescriptor`

### Fields inherited from interface org.springframework.asm.Opcodes

`AALOAD, AASTORE, ACC_ABSTRACT, ACC_ANNOTATION, ACC_BRIDGE, ACC_DEPRECATED, ACC_ENUM, ACC_FINAL, ACC_INTERFACE, ACC_MANDATED, ACC_MODULE, ACC_NATIVE, ACC_OPEN, ACC_PRIVATE, ACC_PROTECTED, ACC_PUBLIC, ACC_RECORD, ACC_STATIC, ACC_STATIC_PHASE, ACC_STRICT, ACC_SUPER, ACC_SYNCHRONIZED, ACC_SYNTHETIC, ACC_TRANSIENT, ACC_TRANSITIVE, ACC_VARARGS, ACC_VOLATILE, ACONST_NULL, ALOAD, ANEWARRAY, ARETURN, ARRAYLENGTH, ASM10_EXPERIMENTAL, ASM4, ASM5, ASM6, ASM7, ASM8, ASM9, ASTORE, ATHROW, BALOAD, BASTORE, BIPUSH, CALOAD, CASTORE, CHECKCAST, D2F, D2I, D2L, DADD, DALOAD, DASTORE, DCMPG, DCMPL, DCONST_0, DCONST_1, DDIV, DLOAD, DMUL, DNEG, DOUBLE, DREM, DRETURN, DSTORE, DSUB, DUP, DUP_X1, DUP_X2, DUP2, DUP2_X1, DUP2_X2, F_APPEND, F_CHOP, F_FULL, F_NEW, F_SAME, F_SAME1, F2D, F2I, F2L, FADD, FALOAD, FASTORE, FCMPG, FCMPL, FCONST_0, FCONST_1, FCONST_2, FDIV, FLOAD, FLOAT, FMUL, FNEG, FREM, FRETURN, FSTORE, FSUB, GETFIELD, GETSTATIC, GOTO, H_GETFIELD, H_GETSTATIC, H_INVOKEINTERFACE, H_INVOKESPECIAL, H_INVOKESTATIC, H_INVOKEVIRTUAL, H_NEWINVOKESPECIAL, H_PUTFIELD, H_PUTSTATIC, I2B, I2C, I2D, I2F, I2L, I2S, IADD, IALOAD, IAND, IASTORE, ICONST_0, ICONST_1, ICONST_2, ICONST_3, ICONST_4, ICONST_5, ICONST_M1, IDIV, IF_ACMPEQ, IF_ACMPNE, IF_ICMPEQ, IF_ICMPGE, IF_ICMPGT, IF_ICMPLE, IF_ICMPLT, IF_ICMPNE, IFEQ, IFGE, IFGT, IFLE, IFLT, IFNE, IFNONNULL, IFNULL, IINC, ILOAD, IMUL, INEG, INSTANCEOF, INTEGER, INVOKEDYNAMIC, INVOKEINTERFACE, INVOKESPECIAL, INVOKESTATIC, INVOKEVIRTUAL, IOR, IREM, IRETURN, ISHL, ISHR, ISTORE, ISUB, IUSHR, IXOR, JSR, L2D, L2F, L2I, LADD, LALOAD, LAND, LASTORE, LCMP, LCONST_0, LCONST_1, LDC, LDIV, LLOAD, LMUL, LNEG, LONG, LOOKUPSWITCH, LOR, LREM, LRETURN, LSHL, LSHR, LSTORE, LSUB, LUSHR, LXOR, MONITORENTER, MONITOREXIT, MULTIANEWARRAY, NEW, NEWARRAY, NOP, NULL, POP, POP2, PUTFIELD, PUTSTATIC, RET, RETURN, SALOAD, SASTORE, SIPUSH, SOURCE_DEPRECATED, SOURCE_MASK, SWAP, T_BOOLEAN, T_BYTE, T_CHAR, T_DOUBLE, T_FLOAT, T_INT, T_LONG, T_SHORT, TABLESWITCH, TOP, UNINITIALIZED_THIS, V_PREVIEW, V1_1, V1_2, V1_3, V1_4, V1_5, V1_6, V1_7, V1_8, V10, V11, V12, V13, V14, V15, V16, V17, V18, V19, V20, V21, V22, V23, V24, V25, V26, V27, V9`

## Constructor Summary

Constructors
Constructor
Description
`CompoundExpression(int startPos, int endPos, SpelNodeImpl... expressionComponents)`

## Method Summary

Modifier and Type
Method
Description
`void`
`generateCode(org.springframework.asm.MethodVisitor mv, CodeFlow cf)`
Generate the bytecode for this node into the supplied `MethodVisitor`.
`TypedValue`
`getValueInternal(ExpressionState state)`
Evaluates a compound expression.
`protected ValueRef`
`getValueRef(ExpressionState state)`
`boolean`
`isCompilable()`
Determine if this node can be compiled to bytecode.
`boolean`
`isWritable(ExpressionState state)`
Determine if this expression node will support a setValue() call.
`TypedValue`
`setValueInternal(ExpressionState state, Supplier<TypedValue> valueSupplier)`
Evaluate the expression to a node and then set the new value created by the specified `Supplier` on that node.
`String`
`toStringAST()`
Return the string form of this AST node.

### Methods inherited from class org.springframework.expression.spel.ast.SpelNodeImpl

`generateCodeForArgument, generateCodeForArguments, generateCodeForArguments, getChild, getChildCount, getEndPosition, getExitDescriptor, getObjectClass, getStartPosition, getTypedValue, getValue, getValue, isNullSafe, nextChildIs, setValue`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### CompoundExpression

public CompoundExpression(int startPos, int endPos, SpelNodeImpl... expressionComponents)

## Method Details

### getValueRef

protected ValueRef getValueRef(ExpressionState state) throws EvaluationException

Overrides:
  `getValueRef` in class `SpelNodeImpl`
Throws:
  `EvaluationException`

### getValueInternal

public TypedValue getValueInternal(ExpressionState state) throws EvaluationException
Evaluates a compound expression. This involves evaluating each piece in turn and the return value from each piece is the active context object for the subsequent piece.

Specified by:
  `getValueInternal` in class `SpelNodeImpl`
Parameters:
  `state` - the state in which the expression is being evaluated
Returns:
  the final value from the last piece of the compound expression
Throws:
  `EvaluationException`

### setValueInternal

public TypedValue setValueInternal(ExpressionState state, Supplier<TypedValue> valueSupplier) throws EvaluationException
Description copied from class: `SpelNodeImpl`
Evaluate the expression to a node and then set the new value created by the specified `Supplier` on that node.

For example, if the expression evaluates to a property reference, then the property will be set to the new value.

Favor this method over `SpelNodeImpl.setValue(ExpressionState, Object)` when the value should be lazily computed.

By default, this method throws a `SpelEvaluationException`, effectively disabling this feature. Subclasses may override this method to provide an actual implementation.

Overrides:
  `setValueInternal` in class `SpelNodeImpl`
Parameters:
  `state` - the current expression state (includes the context)
  `valueSupplier` - a supplier of the new value
Throws:
  `EvaluationException` - if any problem occurs evaluating the expression or setting the new value

### isWritable

public boolean isWritable(ExpressionState state) throws EvaluationException
Description copied from interface: `SpelNode`
Determine if this expression node will support a setValue() call.

Specified by:
  `isWritable` in interface `SpelNode`
Overrides:
  `isWritable` in class `SpelNodeImpl`
Parameters:
  `state` - the current expression state (includes the context)
Returns:
  true if the expression node will allow setValue()
Throws:
  `EvaluationException` - if something went wrong trying to determine if the node supports writing

### toStringAST

public String toStringAST()
Description copied from interface: `SpelNode`
Return the string form of this AST node.

Returns:
  the string form

### isCompilable

public boolean isCompilable()
Description copied from interface: `SpelNode`
Determine if this node can be compiled to bytecode.

The reasoning in each node may be different but will typically involve checking whether the exit type descriptor of the node is known and any relevant child nodes are compilable.

The default implementation returns `false`.

If you override this method, you must also override `SpelNode.generateCode(MethodVisitor, CodeFlow)`.

Returns:
  `true` if this node can be compiled to bytecode
See Also:
  - `SpelNode.generateCode(MethodVisitor, CodeFlow)`

### generateCode

public void generateCode(org.springframework.asm.MethodVisitor mv, CodeFlow cf)
Description copied from interface: `SpelNode`
Generate the bytecode for this node into the supplied `MethodVisitor`.

Context information about the current expression being compiled is available in the supplied `CodeFlow` object — for example, information about the type of the object currently on the stack.

This method will not be invoked unless `SpelNode.isCompilable()` returns `true`.

The default implementation throws an `IllegalStateException` since `SpelNode.isCompilable()` returns `false` by default.

If you override this method, you must also override `SpelNode.isCompilable()`.

Parameters:
  `mv` - the ASM `MethodVisitor` into which code should be generated
  `cf` - a context object with information about what is on the stack
See Also:
  - `SpelNode.isCompilable()`